/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   check_fileformat.c                                 :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/04/24 16:55:41 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/04/25 12:09:56 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "wolf.h"

int			check_fileformat(t_data *d)
{
	int		ret;
	int		y;
	char	**tmptab;

	ret = 1;
	d->width = 0;
	d->height = 0;
	y = 0;
	while (ret > 0)
	{
		ret = get_next_line(d->fd, &d->line);
		tmptab = ft_strsplit(d->line, ' ');
		if (check_fileformat_2(d, ret, tmptab) == -1)
			return (-1);
		if (ret > 0)
			y++;
	}
	d->height = y;
	close(d->fd);
	return (0);
}

int			check_fileformat_2(t_data *d, int ret, char **tmptab)
{
	int		i;
	int		xlen;

	i = 0;
	xlen = 0;
	if (tmptab[i] == NULL)
		return (print_error("Wrong file format\n"));
	while (tmptab[i] != NULL)
	{
		if (check_fileformat_3(&tmptab[i][0], &i) == -1)
			return (-1);
	}
	xlen = i;
	if (xlen > 0 && ret > 0)
	{
		if (d->width == 0)
			d->width = xlen;
		else
		{
			if (d->width != xlen)
				return (print_error("Wrong file format\n"));
		}
	}
	ft_memdel((void **)tmptab);
	return (0);
}

int			check_fileformat_3(char *tmp, int *i)
{
	if (ft_isdigit(tmp[0]) == 0)
		return (print_error("Wrong file format\n"));
	if (ft_atoi(tmp) > 1)
		return (print_error("Wrong file format\n"));
	if (ft_atoi(tmp) < 0)
		return (print_error("Wrong file format\n"));
	(*i)++;
	return (0);
}
