/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   key_bind.c                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/04/22 12:34:57 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/04/25 12:10:07 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "wolf.h"

int		key_hook(int keycode, t_data *d)
{
	if (keycode == 65307)
		exit(0);
	if (keycode == 65361)
		key_left(d);
	if (keycode == 65363)
		key_right(d);
	if (keycode == 65362)
		key_movefront(d);
	if (keycode == 65364)
		key_backpedal(d);
	return (0);
}

void	key_left(t_data *d)
{
	d->olddirx = d->dirx;
	d->dirx = d->dirx * cos(0.15) - d->diry * sin(0.15);
	d->diry = d->olddirx * sin(0.15) + d->diry * cos(0.15);
	d->oldplanex = d->planex;
	d->planex = d->planex * cos(0.15) - d->planey * sin(0.15);
	d->planey = d->oldplanex * sin(0.15) + d->planey * cos(0.15);
	run_wolf(d);
}

void	key_right(t_data *d)
{
	d->olddirx = d->dirx;
	d->dirx = d->dirx * cos(-0.15) - d->diry * sin(-0.15);
	d->diry = d->olddirx * sin(-0.15) + d->diry * cos(-0.15);
	d->oldplanex = d->planex;
	d->planex = d->planex * cos(-0.15) - d->planey * sin(-0.15);
	d->planey = d->oldplanex * sin(-0.15) + d->planey * cos(-0.15);
	run_wolf(d);
}

void	key_movefront(t_data *d)
{
	if (d->map[(int)(d->posx + d->dirx * 0.20)][(int)d->posy] == 0)
		d->posx += d->dirx * 0.20;
	if (d->map[(int)d->posx][(int)(d->posy + d->diry * 0.20)] == 0)
		d->posy += d->diry * 0.20;
	run_wolf(d);
}

void	key_backpedal(t_data *d)
{
	if (d->map[(int)(d->posx - d->dirx * 0.20)][(int)d->posy] == 0)
		d->posx -= d->dirx * 0.20;
	if (d->map[(int)d->posx][(int)(d->posy + d->diry * 0.20)] == 0)
		d->posy -= d->diry * 0.20;
	run_wolf(d);
}
