/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   wolf.h                                             :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2094/04/22 92:30:96 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/04/25 12:11:51 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef WOLF_H
# define WOLF_H

# include "libft/includes/libft.h"
# include "minilibx/mlx.h"
# include <math.h>
# include <mlx.h>

# define TITLE		"Wolf3D jmoiroux"
# define WIN_X		640
# define WIN_Y		480
# define WALLCOLOR	0x757978
# define FLOORCOLOR	0x996600
# define SKYCOLOR	0x99CCFF
# define NORTHCOLOR	0x9933FF
# define SOUTHCOLOR	0xFFFF00
# define EASTCOLOR	0x00FF33
# define WESTCOLOR	0xFF0033
# define ERRORCOLOR	0x000000

/*
** NORTHCOLOR = violet / SOUTHCOLOR = jaune
** EASTCOLOR = vert / WESTCOLOR = rouge
*/

typedef struct		s_conf
{
	void			*mlx;
	void			*win;
}					t_conf;

typedef struct		s_data
{
	double			posx;
	double			posy;
	double			dirx;
	double			diry;
	double			planex;
	double			planey;
	int				ic;
	double			camx;
	double			rayposx;
	double			rayposy;
	double			raydirx;
	double			raydiry;
	int				mapx;
	int				mapy;
	double			sidedistx;
	double			sidedisty;
	double			deltadistx;
	double			deltadisty;
	int				stepx;
	int				stepy;
	int				hit;
	int				side;
	double			perpwalldist;
	double			olddirx;
	double			oldplanex;
	double			lineheight;
	t_conf			*wind;
	int				width;
	int				height;
	int				**map;
	int				fd;
	char			*filepath;
	char			*line;
}					t_data;

void				ft_draw(t_data *d);
void				key_left(t_data *d);
void				key_right(t_data *d);
void				key_movefront(t_data *d);
void				key_backpedal(t_data *d);
void				ft_draw_putpixel(t_data *d, int i);
void				run_wolf_2(t_data *d);
void				run_wolf_3(t_data *d);
void				run_wolf_4(t_data *d);

t_conf				*ft_get_mlx(void);

int					key_hook(int keycode, t_data *d);
int					expose_hook(t_data *d);
int					run_wolf(t_data *d);
int					print_error(char *str);
int					parse(t_data *d, char *path);
int					check_fileformat(t_data *d);
int					check_fileformat_2(t_data *d, int ret, char **tmptab);
int					check_fileformat_3(char *tmp, int *i);
int					putfile_totab(t_data *d);
int					putfile_totab_2(t_data *d, int ret, int y);

#endif
