/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   wolf_mlx.c                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/04/22 12:36:20 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/04/25 12:12:17 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "wolf.h"

int		expose_hook(t_data *d)
{
	run_wolf(d);
	return (0);
}

void	ft_draw(t_data *d)
{
	int		i;
	int		min;
	int		max;

	i = 0;
	min = (d->lineheight < 0) ? WIN_Y / 2 : (WIN_Y - d->lineheight) / 2;
	max = min + d->lineheight;
	while (i < WIN_Y)
	{
		if (i < min)
			mlx_pixel_put(d->wind->mlx, d->wind->win, d->ic, i, SKYCOLOR);
		else if (i < max)
			ft_draw_putpixel(d, i);
		else
			mlx_pixel_put(d->wind->mlx, d->wind->win, d->ic, i, FLOORCOLOR);
		i++;
	}
}

t_conf	*ft_get_mlx(void)
{
	static t_conf	*conf = NULL;

	if (!conf)
	{
		conf = (t_conf *)malloc(sizeof(t_conf));
		conf->mlx = mlx_init();
		conf->win = mlx_new_window(conf->mlx, WIN_X, WIN_Y, TITLE);
	}
	return (conf);
}

void	ft_draw_putpixel(t_data *d, int i)
{
	if (d->side == 1 && d->stepy > 0)
		mlx_pixel_put(d->wind->mlx, d->wind->win, d->ic, i, NORTHCOLOR);
	else if (d->side == 1 && d->stepy < 0)
		mlx_pixel_put(d->wind->mlx, d->wind->win, d->ic, i, SOUTHCOLOR);
	else if (d->side == 0 && d->stepx > 0)
		mlx_pixel_put(d->wind->mlx, d->wind->win, d->ic, i, EASTCOLOR);
	else if (d->side == 0 && d->stepx < 0)
		mlx_pixel_put(d->wind->mlx, d->wind->win, d->ic, i, WESTCOLOR);
	else
		mlx_pixel_put(d->wind->mlx, d->wind->win, d->ic, i, ERRORCOLOR);
}
