/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   wolf_run.c                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/04/22 12:38:08 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/04/25 12:12:29 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "wolf.h"

int		run_wolf(t_data *d)
{
	d->ic = 0;
	while (d->ic < WIN_X)
	{
		run_wolf_2(d);
		run_wolf_3(d);
		run_wolf_4(d);
		if (d->side == 0)
		{
			d->perpwalldist = fabs((d->mapx - d->rayposx +
							(1 - d->stepx) / 2) / d->raydirx);
		}
		else
		{
			d->perpwalldist = fabs((d->mapy - d->rayposy +
							(1 - d->stepy) / 2) / d->raydiry);
		}
		d->lineheight = abs(WIN_Y / d->perpwalldist);
		ft_draw(d);
		d->ic = d->ic + 1;
	}
	return (0);
}

void	run_wolf_2(t_data *d)
{
	d->camx = 2 * d->ic / (double)(WIN_X) - 1;
	d->rayposx = d->posx;
	d->rayposy = d->posy;
	d->raydirx = d->dirx + (d->planex * d->camx);
	d->raydiry = d->diry + (d->planey * d->camx);
	d->mapx = (int)(d->rayposx);
	d->mapy = (int)(d->rayposy);
	d->deltadistx = sqrt(1 + ((d->raydiry * d->raydiry) /
							(d->raydirx * d->raydirx)));
	d->deltadisty = sqrt(1 + ((d->raydirx * d->raydirx) /
							(d->raydiry * d->raydiry)));
	d->hit = 0;
}

void	run_wolf_3(t_data *d)
{
	if (d->raydirx < 0)
	{
		d->stepx = -1;
		d->sidedistx = (d->rayposx - d->mapx) * d->deltadistx;
	}
	else
	{
		d->stepx = 1;
		d->sidedistx = (d->mapx + 1.0 - d->rayposx) * d->deltadistx;
	}
	if (d->raydiry < 0)
	{
		d->stepy = -1;
		d->sidedisty = (d->rayposy - d->mapy) * d->deltadisty;
	}
	else
	{
		d->stepy = 1;
		d->sidedisty = (d->mapy + 1.0 - d->rayposy) * d->deltadisty;
	}
}

void	run_wolf_4(t_data *d)
{
	while (d->hit == 0)
	{
		if (d->sidedistx < d->sidedisty)
		{
			d->sidedistx = d->sidedistx + d->deltadistx;
			d->mapx = d->mapx + d->stepx;
			d->side = 0;
		}
		else
		{
			d->sidedisty = d->sidedisty + d->deltadisty;
			d->mapy = d->mapy + d->stepy;
			d->side = 1;
		}
		if (d->map[d->mapx][d->mapy] > 0)
			d->hit = 1;
	}
}
